<?php
/* add_ons_php */
azp_add_element(
    'custom_field',
    array(
        'name'                    => __('Custom Field', 'easybook-add-ons'),
        // 'desc'                  => __('Custom element for adding third party shortcode','easybook-add-ons'),
        'category'                => __("Filter", 'easybook-add-ons'),
        'icon'                    => ESB_DIR_URL . 'assets/azp-eles-icon/cththemes-logo.png',
        'open_settings_on_create' => true,
        'showStyleTab'            => true,
        'showTypographyTab'       => true,
        'showAnimationTab'        => true,
        'template_folder'         => 'filter/',
        'attrs'                   => array(
            array(
                'type'          => 'text',
                'param_name'    => 'title',
                'show_in_admin' => true,
                'label'         => __('Title', 'easybook-add-ons'),
                // 'desc'                  => '',
                'default'       => 'Field label',
            ),
            array(
                'type'          => 'text',
                'param_name'    => 'fname',
                'show_in_admin' => true,
                'label'         => __('Field Name', 'easybook-add-ons'),
                // 'desc'                  => '',
                'default'       => 'field_name',
            ),
            array(
                'type'          => 'text',
                'param_name'    => 'icon',
                'show_in_admin' => false,
                'label'         => __('Icon', 'easybook-add-ons'),
                // 'desc'                  => '',
                'default'       => 'fal fa-map-marker-question',
            ),
            array(
                'type'          => 'text',
                'param_name'    => 'placeholder',
                'show_in_admin' => false,
                'label'         => __('Placeholder Text', 'easybook-add-ons'),
                // 'desc'                  => '',
                'default'       => 'Search for?',
            ),
            array(
                'type'          => 'select',
                'param_name'    => 'ftype',
                'show_in_admin' => true,
                'label'         => __('Field Type', 'easybook-add-ons'),
                'desc'          => '',
                'default'       => 'text',
                'value'         => array(
                    'text'     => __('Text input field', 'easybook-add-ons'),
                    'number'    => __('Number input field', 'easybook-add-ons'),

                    'select' => __('Select field', 'easybook-add-ons'),
                    'multi' => __('Select multiple', 'easybook-add-ons'),
                    'checkbox' => __('Checkbox field', 'easybook-add-ons'),
                    'radio' => __('Radio field', 'easybook-add-ons'),
                ),
            ),

            array(
                'type'        => 'repeater',
                'param_name'  => 'options',
                // 'show_in_admin'         => true,
                'label'       => __('Field Options (Select and Checkbox type)', 'easybook-add-ons'),
                'desc'        => '',
                'title_field' => 'title',
                'fields'      => array(
                    array(
                        'type'          => 'text',
                        'param_name'    => 'title',
                        'show_in_admin' => true,
                        'label'         => __('Title', 'easybook-add-ons'),
                        'desc'          => '',
                        'default'       => 'Option Title',
                    ),
                    array(
                        'type'          => 'text',
                        'param_name'    => 'value',
                        'show_in_admin' => true,
                        'label'         => __('Value', 'easybook-add-ons'),
                        'desc'          => '',
                        'default'       => 'value_text',
                    ),
                ),
                'default'     => urlencode(json_encode(array())),
            ),
            
            array(
                'type'          => 'select',
                'param_name'    => 'width',
                'show_in_admin' => true,
                'label'         => __('Width', 'easybook-add-ons'),
                // 'desc'                  => 'Select how to sort retrieved posts.',
                'default'       => '12',
                'value'         => array(
                    '12' => __('1/1', 'easybook-add-ons'),
                    '10' => __('5/6', 'easybook-add-ons'),
                    '9'  => __('3/4', 'easybook-add-ons'),
                    '8'  => __('2/3', 'easybook-add-ons'),
                    '7'  => __('7/12', 'easybook-add-ons'),
                    '6'  => __('1/2', 'easybook-add-ons'),
                    '5'  => __('5/12', 'easybook-add-ons'),
                    '4'  => __('1/3', 'easybook-add-ons'),
                    '3'  => __('1/4', 'easybook-add-ons'),
                    '2'  => __('1/6', 'easybook-add-ons'),
                    '1'  => __('1/12', 'easybook-add-ons'),

                ),
            ),
            array(
                'type'       => 'text',
                'param_name' => 'el_id',
                'label'      => __('Element ID', 'easybook-add-ons'),
                // 'desc'                  => '',
                'default'    => '',
            ),
            array(
                'type'       => 'text',
                'param_name' => 'el_class',
                'label'      => __('Extra Class', 'easybook-add-ons'),
                'desc'       => __("Use this field to add a class name and then refer to it in your CSS.", 'easybook-add-ons'),
                'default'    => '',
            ),
        ),
    )
);
