<?php
/* add_ons_php */
vc_map( array(
    "name"                      => esc_html__("Our Partners", 'easybook-add-ons'),
    "description"               => esc_html__("Our Partners",'easybook-add-ons'),
    "base"                      => "our_partners_vc",
    "icon"                      => ESB_ABSPATH . "assets/cththemes-logo.png",
    "category"                  => __( 'EasyBook Theme', 'easybook-add-ons' ),
    "content_element"           => true,
    "show_settings_on_create"   => true,
    "params"                    => array(
        array(
            "type"          => "attach_images",
            "holder"        => "div",
            "class"         => "cth-vc-images",
            "heading"       => esc_html__("Partners Images", 'easybook-add-ons'),
            "param_name"    => "partnerimgs",
        ),
        array(
            "type"        => "textfield",
            "heading"     => __("Partner Links", 'easybook-add-ons'),
            "param_name"  => "links",
            "admin_label" => true,
            "value"       => "#|#|#|#|#|#",
            'description' => __( 'Enter links for each partner (Note: divide links with linebreaks (Enter) or | and no spaces).', 'easybook-add-ons' ),
        ),
        array(
            "type" => "checkbox",
            "admin_label"   => true,
            "heading" => esc_html__("Is External Links", 'easybook-add-ons'),
            "param_name" => "is_external",
            "value" => array( 
                esc_html__('Yes', 'easybook-add-ons') => 'yes',   
            ),
            "std"=>'yes',
        ),
        
        array(
            "type"          => "textfield",
            "heading"       => esc_html__("Extra class name", 'easybook-add-ons'),
            "param_name"    => "el_class",
            "description"   => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'easybook-add-ons'),
            "value"         => "",
        ),
        array(
            'type'          => 'css_editor',
            'heading'       => esc_html__( 'Css', 'easybook-add-ons' ),
            'param_name'    => 'css',
            'group'         => esc_html__( 'Design options', 'easybook-add-ons' ),
        ),
    ),
    'admin_enqueue_js'      => ESB_ABSPATH . "assets/js/wpbakerry-eles.js", // need "holder"    => "div" and "class"     => "cth-vc-images" option for attach_image, attach_images type
    'js_view'=> 'CTHVCImages',
));
if ( class_exists( 'WPBakeryShortCode' ) ) {
    class WPBakeryShortCode_Our_Partners_Vc extends WPBakeryShortCode {}
}