<?php
/* add_ons_php */

defined( 'ABSPATH' ) || exit;

class Esb_Class_Emails{
    public static function init(){
       add_action( 'easybook_addons_insert_listing_after',array( __CLASS__, 'insert_listing_after' ), 10, 2 );
       add_action( 'easybook_addons_insert_order_after',array( __CLASS__, 'insert_order_after' ), 10, 3 );
       add_action( 'easybook_addons_order_completed', array( __CLASS__, 'order_completed' ));
       add_action( 'easybook_addons_cthclaim_approved', array( __CLASS__, 'cthclaim_approved' ), 10, 3 );
       add_action( 'easybook_addons_lclaim_change_status_to_decline', array( __CLASS__, 'lclaim_change_status_to_decline' ), 10, 1 );
       add_action( 'easybook_addons_new_invoice', array( __CLASS__, 'new_invoice' ));
       add_action( 'easybook_addons_insert_booking_after',array( __CLASS__, 'insert_booking_after' ));
       add_action( 'easybook_addons_booking_request_after',array( __CLASS__, 'insert_booking_after' ));
       add_action('esb_insert_booking_after', array(__CLASS__, 'insert_booking_after'));
       add_action( 'easybook_addons_edit_booking_approved',array( __CLASS__, 'edit_booking_approved' )); 
       add_action( 'easybook_addons_lclaim_change_status_to_asked_charge',array( __CLASS__, 'lclaim_change_status_to_asked_charge' ), 10, 1 );
    
        add_action( 'cth_chat_reply_after',array( __CLASS__, 'chat_reply_email' ), 10, 1 );
        add_action( 'easybook_addons_insert_message_after',array( __CLASS__, 'author_message_to_email' ), 10, 2 );



    }
    public static function wp_mail_from_name( $name){
        return easybook_addons_get_option('emails_name')? easybook_addons_get_option('emails_name'): $name;
    }
    public static function wp_mail_from( $email){
        return easybook_addons_get_option('emails_email')? easybook_addons_get_option('emails_email'): $email;
    }
    public static function do_wp_mail( $to, $subject='', $message='', $headers = array(), $attachments = array()){
        if(easybook_addons_get_option('emails_ctype') == 'html'){ 
            $headers[] = 'Content-Type: text/html; charset=UTF-8';
        }
        //$headers[] = 'From: '. $sender_option.' ' . '<'.$sender_email_option.'>';
        add_filter( 'wp_mail_from_name', array( __CLASS__, 'wp_mail_from_name' ));
        add_filter('wp_mail_from', array( __CLASS__, 'wp_mail_from' ));
        // $headers[] = 'Reply-To: '.self::wp_mail_from_name(__( 'Sender Name', 'easybook-add-ons' )) .' ' . '<'.self::wp_mail_from(__( 'senderemail@gmail.com', 'easybook-add-ons' )).'>';

        $email_sent = wp_mail( $to, $subject , $message , $headers, $attachments );

        remove_filter( 'wp_mail_from_name', array( __CLASS__, 'wp_mail_from_name' ));
        remove_filter('wp_mail_from', array( __CLASS__, 'wp_mail_from' ));

        return $email_sent;   
    }
    public static function process_email_template($email_template = '', $email_vars = array()){
        $email_vars = array_merge($email_vars,array('site_title' => get_bloginfo('name')));
        // get allow variables
        $allow_field_names = array_keys($email_vars);
        // extract variables, skip if existing
        extract($email_vars, EXTR_SKIP);
        if(preg_match_all("/{([\w\-_]+)[^\w\-_]*}/", $email_template, $matches) != FALSE){
            $fieldsPattern = array();//$matches[0];
            $fieldsReplace = array();
            foreach ($matches[1] as $key => $fn) {
                $fieldsPattern[] = "/{(".$fn.")[^\w\-_]*}/";
                if( isset($$fn) && in_array($fn, $allow_field_names ) ){
                    $fieldsReplace[] = $$fn;  //'['.$fn.']';
                }else{
                    $fieldsReplace[] = '{'.$fn.'}';
                } 
            }
            $email_template = preg_replace($fieldsPattern, $fieldsReplace, $email_template);
        }
        return $email_template;
    }
    public static function insert_listing_after($listing_id = 0, $is_editing_listing = true){
         if($is_editing_listing == false){
            $listing_post = get_post($listing_id);
            if (null != $listing_post){
                $cats = array();
                $terms = get_the_terms($listing_post,'listing_cat'); 
                if ( $terms && ! is_wp_error( $terms ) ){
                    
                    foreach ( $terms as $term ) {
                        $cats[] = $term->name;
                    }
                }
                $current_user = wp_get_current_user();

                // send admin notification email
                $email_recipients = easybook_addons_get_option('emails_admin_new_listing_recipients') ? easybook_addons_get_option('emails_admin_new_listing_recipients') : get_bloginfo('admin_email') ;
                if(easybook_addons_get_option('emails_admin_new_listing_enable') == 'yes'){
                    
                    $subj_args = array(
                        'listing_number' => $listing_post->ID,
                        'listing_title' => $listing_post->post_title,
                        'listing_date' => $listing_post->post_date,
                    );
                    
                    $email_subject = self::process_email_template(easybook_addons_get_option('emails_admin_new_listing_subject'), $subj_args);
                    $temp_args = array(
                        'listing_number' => $listing_post->ID,
                        'listing_author' => $current_user->display_name,
                        'listing_title' => $listing_post->post_title,
                        'listing_category' => implode(", ", $cats),
                        'listing_excerpt' => $listing_post->post_excerpt,
                        'listing_date' => $listing_post->post_date,
                        'author_email' => $current_user->user_email,
                        
                    );
                    
                    $email_template = self::process_email_template(easybook_addons_get_option('emails_admin_new_listing_temp'), $temp_args);
                    
                    $headers = array( 'Reply-To: '.$current_user->display_name .' ' . '<'.$current_user->user_email.'>' );
                    self::do_wp_mail( $email_recipients, $email_subject, $email_template, $headers);
                }
                // end new listing author email
                // send listing author email
                if(easybook_addons_get_option('emails_auth_new_listing_enable') == 'yes'){
                    
                    $subj_args = array(
                        'listing_title' => $listing_post->post_title,
                    );
                    
                    $email_subject = self::process_email_template(easybook_addons_get_option('emails_auth_new_listing_subject'), $subj_args);
                    $temp_args = array(
                        'listing_number' => $listing_post->ID,
                        'listing_author' => $current_user->display_name,
                        'listing_title' => $listing_post->post_title,
                        'listing_category' => implode(", ", $cats),
                        'listing_dashboard' => get_permalink(esb_addons_get_wpml_option('dashboard_page')),
                    );
                    
                    $email_template = self::process_email_template(easybook_addons_get_option('emails_auth_new_listing_temp'), $temp_args);
                    
                    $auth_replies = array();
                    foreach ((array)$email_recipients as $em) {
                        $auth_replies[] = '<'.$em.'>';
                    }
                    
                    $headers = array( 'Reply-To: '. implode(',', $auth_replies) );

                    self::do_wp_mail( $current_user->user_email, $email_subject, $email_template, $headers);
                }
                // end new listing author email
                    
            }
            // if is correct listing
        }
        // send email for submit new listing only
    }
    public static function insert_order_after($order_id = 0, $plan_id = 0, $listing_id = 0 ){
        if(is_numeric($order_id)&&(int)$order_id > 0){
            $order_post = get_post($order_id);
            if (null != $order_post){
                $plan_post = get_post($plan_id);
                if (null != $plan_post){
                    // need to check if the order is for ad campaign
                    
                    // send admin notification email
                    if(easybook_addons_get_option('emails_admin_new_order_enable') == 'yes'){
                        
                        $subj_args = array(
                            'order_number' => $order_post->ID,
                            'order_date' => $order_post->post_date,
                        );
                        // $email_subject = easybook_addons_process_email_template(easybook_addons_get_option('emails_admin_new_order_subject'), $subj_args);
                        $email_subject = self::process_email_template(easybook_addons_get_option('emails_admin_new_order_subject'), $subj_args);
                        $temp_args = array(
                            'author' => get_post_meta( $order_id, ESB_META_PREFIX.'display_name', true ),
                            'order_amount' => easybook_addons_get_price_formated( get_post_meta( $order_id, ESB_META_PREFIX.'amount', true ) ),
                            // 'order_currency' => get_post_meta( $order_id, ESB_META_PREFIX.'currency_code', true ),
                            'order_method' => easybook_addons_payment_names(get_post_meta( $order_id, ESB_META_PREFIX.'payment_method', true )),
                            'order_title' => $order_post->post_title,
                            'order_number' => $order_post->ID,
                            'order_date' => $order_post->post_date,
                            // 'listing_title' => $listing_post->post_title,
                            // 'listing_category' => implode(", ", $cats),
                            'plan_title' => $plan_post->post_title,
                            
                            'notes'         => get_post_meta( $order_id, ESB_META_PREFIX.'notes', true ),
                        );
                        // $email_template = easybook_addons_process_email_template(easybook_addons_get_option('emails_admin_new_order_temp'), $temp_args);
                        $email_template = self::process_email_template(easybook_addons_get_option('emails_admin_new_order_temp'), $temp_args);
                        $email_recipients = easybook_addons_get_option('emails_admin_new_order_recipients') ? easybook_addons_get_option('emails_admin_new_order_recipients') : get_bloginfo('admin_email') ;
                        // easybook_addons_do_wp_mail( $email_recipients, $email_subject, $email_template);
                        self::do_wp_mail( $email_recipients, $email_subject, $email_template);
                    }
                    // end new order admi email
                }
                // end if plan_post
            }
            // end if order_post
        }
    }
    public static function order_completed($order_id = 0){
        if(is_numeric($order_id)&&(int)$order_id > 0){
            $order_post = get_post($order_id);
            if (null != $order_post){
                $plan_post = get_post(get_post_meta( $order_id, ESB_META_PREFIX.'plan_id', true ));
                if (null != $plan_post){
                    $listing_author_email = get_post_meta( $order_id, ESB_META_PREFIX.'email', true );
                    // send admin notification email
                    if(easybook_addons_get_option('emails_admin_order_completed_enable') == 'yes'){
                        
                        $subj_args = array(
                            'order_number' => $order_post->ID,
                            'order_date' => $order_post->post_date,
                        );
                        // $email_subject = easybook_addons_process_email_template(easybook_addons_get_option('emails_admin_order_completed_subject'), $subj_args);
                        $email_subject = self::process_email_template(easybook_addons_get_option('emails_admin_order_completed_subject'), $subj_args);
                        $temp_args = array(
                            'author' => get_post_meta( $order_id, ESB_META_PREFIX.'display_name', true ),
                            'order_amount' => easybook_addons_get_price_formated( get_post_meta( $order_id, ESB_META_PREFIX.'amount', true ) ),
                            // 'order_currency' => get_post_meta( $order_id, ESB_META_PREFIX.'currency_code', true ),
                            'order_method' => easybook_addons_payment_names(get_post_meta( $order_id, ESB_META_PREFIX.'payment_method', true )),
                            'order_title' => $order_post->post_title,
                            'order_number' => $order_post->ID,
                            'order_date' => $order_post->post_date,
                            'plan_title' => $plan_post->post_title,
                            // 'listing_title' => $listing_post->post_title,
                            // 'listing_category' => implode(", ", $cats),
                            'notes'         => get_post_meta( $order_id, ESB_META_PREFIX.'notes', true ),
                        );
                        // $email_template = easybook_addons_process_email_template(easybook_addons_get_option('emails_admin_order_completed_temp'), $temp_args);
                        $email_template = self::process_email_template(easybook_addons_get_option('emails_admin_order_completed_temp'), $temp_args);
                        $email_recipients = easybook_addons_get_option('emails_admin_order_completed_recipients') ? easybook_addons_get_option('emails_admin_order_completed_recipients') : get_bloginfo('admin_email') ;
                        // easybook_addons_do_wp_mail( $email_recipients, $email_subject, $email_template);
                        self::do_wp_mail( $email_recipients, $email_subject, $email_template);
                    }
                    // end new order admin email

                    // send author notification email
                    if(easybook_addons_get_option('emails_auth_order_completed_enable') == 'yes' && $listing_author_email !=''){
                        
                        $subj_args = array(
                            'order_number' => $order_post->ID,
                            'order_date' => $order_post->post_date,
                        );
                        // $email_subject = easybook_addons_process_email_template(easybook_addons_get_option('emails_auth_order_completed_subject'), $subj_args);
                        $email_subject = self::process_email_template(easybook_addons_get_option('emails_auth_order_completed_subject'), $subj_args);
                        $temp_args = array(
                            'author' => get_post_meta( $order_id, ESB_META_PREFIX.'display_name', true ),
                            'order_amount' => easybook_addons_get_price_formated( get_post_meta( $order_id, ESB_META_PREFIX.'amount', true ) ),
                            // 'order_currency' => get_post_meta( $order_id, ESB_META_PREFIX.'currency_code', true ),
                            'order_method' => easybook_addons_payment_names(get_post_meta( $order_id, ESB_META_PREFIX.'payment_method', true )),
                            'order_title' => $order_post->post_title,
                            'order_number' => $order_post->ID,
                            'order_date' => $order_post->post_date,
                            'plan_title' => $plan_post->post_title,
                            // 'listing_title' => $listing_post->post_title,
                            // 'listing_category' => implode(", ", $cats),
                            'notes'         => get_post_meta( $order_id, ESB_META_PREFIX.'notes', true ),
                        );
                        // $email_template = easybook_addons_process_email_template(easybook_addons_get_option('emails_auth_order_completed_temp'), $temp_args);
                        $email_template = self::process_email_template(easybook_addons_get_option('emails_auth_order_completed_temp'), $temp_args);
                        
                        // easybook_addons_do_wp_mail( $listing_author_email, $email_subject, $email_template);
                        self::do_wp_mail( $listing_author_email, $email_subject, $email_template);
                    }
                    // end new order author email
                }
                // end if plan_post
            }
            // end if order_post
        }    
    }
    public static function cthclaim_approved($claim_id = 0, $listing_id = 0, $user_id = 0){
        if(is_numeric($claim_id)&&(int)$claim_id > 0){
            $listing_id                     = get_post_meta( $claim_id, ESB_META_PREFIX.'listing_id', true );
            $user_id                        = get_post_meta( $claim_id, ESB_META_PREFIX.'user_id', true );
            
            $listing_post = get_post($listing_id);
            $user_info = get_userdata($user_id);

            $subject = apply_filters( 'easybook-addons-claim-approved-subject', __( 'Claim listing approved', 'easybook-add-ons' ) );
            $body = apply_filters( 'easybook-addons-claim-approved-body', sprintf(__( '{site_title}<br />Your claimed listing <a href="%2$s">%1$s</a> is approved.<br />Thank you.', 'easybook-add-ons' ), $listing_post->post_title, get_permalink($listing_post->ID) ) );

            $email_template =  self::process_email_template($body,array());
            self::do_wp_mail( $user_info->user_email, $subject,$email_template);
        }    
    }
    public static function lclaim_change_status_to_decline($claim_id = 0){
        if(is_numeric($claim_id)&&(int)$claim_id > 0){
            $listing_id                     = get_post_meta( $claim_id, ESB_META_PREFIX.'listing_id', true );
            $user_id                        = get_post_meta( $claim_id, ESB_META_PREFIX.'user_id', true );
            
            $listing_post = get_post($listing_id);
            $user_info = get_userdata($user_id);

            $subject = apply_filters( 'easybook-addons-claim-declined-subject', __( 'Claim listing declined', 'easybook-add-ons' ) );
            $body = apply_filters( 'easybook-addons-claim-declined-body', sprintf(__( '{site_title}<br />Your claimed listing for %s is declined.<br />Thank you.', 'easybook-add-ons' ), $listing_post->post_title, get_permalink($listing_post->ID) ) );

            $email_template = $this->process_email_template($body,array());
            self::do_wp_mail( $user_info->user_email, $subject,$email_template);
        }     
    }
    public static function new_invoice($invoice_id = 0){
        if(is_numeric($invoice_id)&&(int)$invoice_id > 0){
            $invoice_post = get_post($invoice_id);
            if (null != $invoice_post){

                $listing_author_email = get_post_meta( $invoice_id, ESB_META_PREFIX.'user_email', true );
                // send admin notification email
                if(easybook_addons_get_option('emails_admin_new_invoice_enable') == 'yes'){
                    
                    $subj_args = array(
                        'number' => $invoice_post->ID,
                        'date' => $invoice_post->post_date,
                    );
                    // $email_subject = easybook_addons_process_email_template(easybook_addons_get_option('emails_admin_new_invoice_subject'), $subj_args);
                    $email_subject = self::process_email_template(easybook_addons_get_option('emails_admin_new_invoice_subject'), $subj_args);
                    $temp_args = Esb_Class_Invoice_CPT::get_invoice_datas($invoice_post);
                    // $email_template = easybook_addons_process_email_template(easybook_addons_get_option('emails_admin_new_invoice_temp'), $temp_args);
                    $email_template = self::process_email_template(easybook_addons_get_option('emails_admin_new_invoice_temp'), $temp_args);
                    $email_recipients = easybook_addons_get_option('emails_admin_new_invoice_recipients') ? easybook_addons_get_option('emails_admin_new_invoice_recipients') : get_bloginfo('admin_email') ;
                    // easybook_addons_do_wp_mail( $email_recipients, $email_subject, $email_template);
                    self::do_wp_mail( $email_recipients, $email_subject, $email_template);
                }
                // end new order admin email

                // send author notification email
                if(easybook_addons_get_option('emails_auth_new_invoice_enable') == 'yes' && $listing_author_email !=''){
                    
                    $subj_args = array(
                        'number' => $invoice_post->ID,
                        'date' => $invoice_post->post_date,
                    );
                    // $email_subject = easybook_addons_process_email_template(easybook_addons_get_option('emails_auth_new_invoice_subject'), $subj_args);
                    $email_subject = self::process_email_template(easybook_addons_get_option('emails_auth_new_invoice_subject'), $subj_args);
                    $temp_args = Esb_Class_Invoice_CPT::get_invoice_datas($invoice_post);
                    // $email_template = easybook_addons_process_email_template(easybook_addons_get_option('emails_auth_new_invoice_temp'), $temp_args);
                    $email_template = self::process_email_template(easybook_addons_get_option('emails_auth_new_invoice_temp'), $temp_args);
                    
                    // easybook_addons_do_wp_mail( $listing_author_email, $email_subject, $email_template);
                    self::do_wp_mail( $listing_author_email, $email_subject, $email_template);
                }
                // end new order author email


            }
            // end if invoice_post
        }   
    }
    public static function insert_booking_after($booking_id = 0){
        if(is_numeric($booking_id)&&(int)$booking_id > 0){
            $booking_post = get_post($booking_id);
            if (null != $booking_post){
                $listing_id = get_post_meta( $booking_id, ESB_META_PREFIX.'listing_id', true );
                $listing_post = get_post($listing_id);
                if (null != $listing_post){
                    
                    $user_obj = get_userdata(get_post_meta( $booking_id, ESB_META_PREFIX.'user_id', true ));
                    if( $user_obj ){
                        $lb_name = $user_obj->display_name;
                        $lb_email = $user_obj->user_email;
                        $lb_phone = get_user_meta( $user_obj->ID, ESB_META_PREFIX.'phone', true);
                    }else{
                        $lb_name = get_post_meta( $booking_id, ESB_META_PREFIX.'lb_name', true );
                        $lb_email = get_post_meta( $booking_id, ESB_META_PREFIX.'lb_email', true );
                        $lb_phone = get_post_meta( $booking_id, ESB_META_PREFIX.'lb_phone', true );

                    }
                    if( empty($lb_phone) ) $lb_phone = get_post_meta( $booking_id, ESB_META_PREFIX.'lb_phone', true );

                    $booking_rooms = get_post_meta( $booking_id, ESB_META_PREFIX.'rooms', true );
                    
                    $room_details = self::booking_rooms($booking_id);
                    $room_details_new = self::booking_rooms_new($booking_id);
                    $room_details_old = self::booking_rooms_old($booking_id);

                    $ticket_details = self::booking_tickets($booking_id);
                    $tour_slots_details = self::booking_tour_slots($booking_id);

                    $booking_services = self::booking_services($booking_id);


                    $lb_adults     = get_post_meta( $booking_id, ESB_META_PREFIX.'adults', true );
                    $lb_children  = get_post_meta( $booking_id, ESB_META_PREFIX.'children', true );
                    $lb_infants  = get_post_meta( $booking_id, ESB_META_PREFIX.'infants', true );
                    $person = (int)$lb_adults + (int)$lb_children + (int)$lb_infants;
                    $listing_author = get_user_by( 'ID', $listing_post->post_author );

                    $email_recipients = array();
                    if( $listing_author ) $email_recipients[] = $listing_author->user_email;
                    // also send to site owner
                    $email_recipients[] = get_bloginfo('admin_email');

                    $bktimes = get_post_meta($booking_id, ESB_META_PREFIX . 'times', true);
                    if (!empty($bktimes)) {
                        $bktimes = implode('<br \>', $bktimes);
                    }

                    $bkslots = get_post_meta($booking_id, ESB_META_PREFIX . 'time_slots', true);
                    if (!empty($bkslots)) {
                        
                        $tSlots = array();
                        foreach ($bkslots as $bkslot) {
                            $bkslot = (array)$bkslot;
                            $tSlots[] = $bkslot['title'];
                            // $slkey = array_search($bkslot, array_column($listing_slots, 'slot_id'));
                            // if( false !== $slkey ){
                            //     $tSlots[] = $listing_slots[$slkey]['time'];
                            // }
                        }
                        $bkslots = implode('<br \>', $tSlots);
                    }

                    $checkin = get_post_meta($booking_id, ESB_META_PREFIX . 'checkin', true);
                    if ($checkin != '') {
                        $checkin = Esb_Class_Date::i18n($checkin);
                    }

                    $checkout = get_post_meta($booking_id, ESB_META_PREFIX . 'checkout', true);
                    if ($checkout != '') {
                        $checkout = Esb_Class_Date::i18n($checkout);
                    }


                    $temp_args = array(
                        'author' => $listing_author->display_name,
                        'name' => $lb_name,
                        'email' => $lb_email,
                        'phone' => $lb_phone,
                        'day' => get_post_meta( $booking_id, ESB_META_PREFIX.'nights', true ),
                        'person' => $person,
                        'listing_title' => $listing_post->post_title,
                        'room_type'         => $room_details,
                        'rooms'             => $room_details,
                        'rooms_dates'       => $room_details_old,
                        'rooms_persons'     => $room_details_new,

                        
                        // olb booking form
                        'quantity' => get_post_meta( $booking_id, ESB_META_PREFIX.'lb_quantity', true ),
                        'date' => get_post_meta( $booking_id, ESB_META_PREFIX.'lb_date', true ),
                        'time' => get_post_meta( $booking_id, ESB_META_PREFIX.'lb_time', true ),
                        'info' => get_post_meta( $booking_id, ESB_META_PREFIX.'lb_add_info', true ),

                        'checkin'       => $checkin,
                        'checkout'      => $checkout,

                        'times'         => $bktimes,
                        'slots'         => $bkslots,

                        'notes'          => get_post_meta($booking_id, ESB_META_PREFIX . 'notes', true),

                        'adults' => $lb_adults,
                        'children' => $lb_children,
                        'infants' => $lb_infants,

                        'tickets'           => $ticket_details,
                        'tour_slots'        => $tour_slots_details,
                        'booking_services'      => $booking_services,

                        'total'             => easybook_addons_get_price_formated( get_post_meta($booking_id, ESB_META_PREFIX . 'price_total', true) ), 
                        'payment_method'    => easybook_addons_payment_names(get_post_meta( $booking_id, ESB_META_PREFIX.'payment_method', true )),
                    );

                    $temp_args = (array)apply_filters( 'listing_booking_email_args', $temp_args, $booking_id, $listing_id );

                    if(easybook_addons_get_option('emails_section_auth_booking_insert_enable') == 'yes'){
                     
                        $subj_args = array(
                            'listing_title' => $listing_post->post_title,
                        );
                        // $email_subject = easybook_addons_process_email_template(easybook_addons_get_option('emails_section_auth_booking_insert_subject'), $subj_args);
                        $email_subject = self::process_email_template(easybook_addons_get_option('emails_section_auth_booking_insert_subject'), $subj_args);
                        
                        // $email_template = easybook_addons_process_email_template(easybook_addons_get_option('emails_section_auth_booking_insert_temp'), $temp_args);
                        $email_template = self::process_email_template(easybook_addons_get_option('emails_section_auth_booking_insert_temp'), $temp_args);
                
                        // easybook_addons_do_wp_mail( $email_recipients, $email_subject, $email_template);

                        $headers = array( 'Reply-To: '.$lb_name .' ' . '<'.$lb_email.'>' );
                
                        self::do_wp_mail( $email_recipients, $email_subject, $email_template, $headers );
                    }
                    // listing author/admin emails

                    

                    if(easybook_addons_get_option('emails_section_customer_booking_insert_enable') == 'yes' && $lb_email != '' ){
                        
                        $subj_args = array(
                            'listing_title' => $listing_post->post_title,
                        );
                        // $email_subject = easybook_addons_process_email_template(easybook_addons_get_option('emails_section_customer_booking_insert_subject'), $subj_args);
                        $email_subject = self::process_email_template(easybook_addons_get_option('emails_section_customer_booking_insert_subject'), $subj_args);

                        
                        // $email_template = easybook_addons_process_email_template(easybook_addons_get_option('emails_section_customer_booking_insert_temp'), $temp_args);
                        $email_template = self::process_email_template(easybook_addons_get_option('emails_section_customer_booking_insert_temp'), $temp_args);
                        
                        $auth_replies = array();
                        foreach ($email_recipients as $em) {
                            $auth_replies[] = '<'.$em.'>';
                        }
                        
                        $headers = array( 'Reply-To: '. implode(',', $auth_replies) );
                        
                        self::do_wp_mail( $lb_email, $email_subject, $email_template, $headers);
                    }
                    // listing customer email
                }
                // end if is valid listing
            }
            // end if is valid booking

        }

    }
    public static function edit_booking_approved($booking_id = 0){
        if(is_numeric($booking_id)&&(int)$booking_id > 0){
            $booking_post = get_post($booking_id);
            if (null != $booking_post){
                $listing_id = get_post_meta( $booking_id, ESB_META_PREFIX.'listing_id', true );
                $listing_post = get_post($listing_id);
                if (null != $listing_post){
                    
                    $user_obj = get_userdata(get_post_meta( $booking_id, ESB_META_PREFIX.'user_id', true ));
                    if( $user_obj ){
                        $lb_name = $user_obj->display_name;
                        $lb_email = $user_obj->user_email;
                        $lb_phone = get_user_meta( $user_obj->ID, '_cth_phone', true);
                    }else{
                        $lb_name = get_post_meta( $booking_id, ESB_META_PREFIX.'name', true );
                        $lb_email = get_post_meta( $booking_id, ESB_META_PREFIX.'email', true );
                        $lb_phone = get_post_meta( $booking_id, ESB_META_PREFIX.'phone', true );

                    }
                    $booking_rooms = get_post_meta( $booking_id, ESB_META_PREFIX.'rooms', true );
                    
                    $room_details = self::booking_rooms($booking_id);
                    $room_details_new = self::booking_rooms_new($booking_id);
                    $room_details_old = self::booking_rooms_old($booking_id);

                    $ticket_details = self::booking_tickets($booking_id);
                    $tour_slots_details = self::booking_tour_slots($booking_id);

                    $booking_services = self::booking_services($booking_id);

                    $lb_adults     = get_post_meta( $booking_id, ESB_META_PREFIX.'adults', true );
                    $lb_children  = get_post_meta( $booking_id, ESB_META_PREFIX.'children', true );
                    $lb_infants  = get_post_meta( $booking_id, ESB_META_PREFIX.'infants', true );
                    $person = (int)$lb_adults + (int)$lb_children + (int)$lb_infants;
                    $listing_author = get_user_by( 'ID', $listing_post->post_author );
                    if(easybook_addons_get_option('emails_section_customer_booking_approved_enable') == 'yes' && $lb_email != '' ){
                        
                        $subj_args = array(
                            'listing_title' => $listing_post->post_title,
                        );
                        // $email_subject = easybook_addons_process_email_template(easybook_addons_get_option('emails_section_customer_booking_approved_subject'), $subj_args);
                        $email_subject = self::process_email_template(easybook_addons_get_option('emails_section_customer_booking_approved_subject'), $subj_args);
                        
                        $bktimes = get_post_meta( $booking_id, ESB_META_PREFIX.'times', true );
                        if( !empty($bktimes) ) $bktimes = implode('<br \>', $bktimes);

                        $bkslots = get_post_meta($booking_id, ESB_META_PREFIX . 'time_slots', true);
                        if (!empty($bkslots)) {
                            
                            $tSlots = array();
                            foreach ($bkslots as $bkslot) {
                                $bkslot = (array)$bkslot;
                                $tSlots[] = $bkslot['title'];
                                // $slkey = array_search($bkslot, array_column($listing_slots, 'slot_id'));
                                // if( false !== $slkey ){
                                //     $tSlots[] = $listing_slots[$slkey]['time'];
                                // }
                            }
                            $bkslots = implode('<br \>', $tSlots);
                        }

                        $checkin = get_post_meta( $booking_id, ESB_META_PREFIX.'checkin', true );
                        if( $checkin != '' ) $checkin = Esb_Class_Date::i18n( $checkin );
                        $checkout = get_post_meta( $booking_id, ESB_META_PREFIX.'checkout', true );
                        if( $checkout != '' ) $checkout = Esb_Class_Date::i18n( $checkout );


                        $temp_args = array(
                            'author' => $listing_author->display_name,
                            'name' => $lb_name,
                            'email' => $lb_email,
                            'phone' => $lb_phone,
                            'day' => get_post_meta( $booking_id, ESB_META_PREFIX.'nights', true ),
                            'person' => $person,
                            'listing_title' => $listing_post->post_title,
                            'room_type'         => $room_details,
                            'rooms'             => $room_details,
                            'rooms_dates'       => $room_details_old,
                            'rooms_persons'     => $room_details_new,
                            
                            // olb booking form
                            'quantity' => get_post_meta( $booking_id, ESB_META_PREFIX.'lb_quantity', true ),
                            'date' => get_post_meta( $booking_id, ESB_META_PREFIX.'lb_date', true ),
                            'time' => get_post_meta( $booking_id, ESB_META_PREFIX.'lb_time', true ),
                            'info' => get_post_meta( $booking_id, ESB_META_PREFIX.'lb_add_info', true ),

                            'checkin' => $checkin,
                            'checkout' => $checkout,

                            'times' => $bktimes,
                            'slots' => $bkslots,

                            'notes'          => get_post_meta($booking_id, ESB_META_PREFIX . 'notes', true),

                            'adults' => $lb_adults,
                            'children' => $lb_children,
                            'infants' => $lb_infants,

                            'tickets'           => $ticket_details,
                            'tour_slots'        => $tour_slots_details,
                            'booking_services'      => $booking_services,

                            'total'             => easybook_addons_get_price_formated( get_post_meta($booking_id, ESB_META_PREFIX . 'price_total', true) ), 
                            'payment_method'    => easybook_addons_payment_names(get_post_meta( $booking_id, ESB_META_PREFIX.'payment_method', true )),
                        );
                        // $email_template = easybook_addons_process_email_template(easybook_addons_get_option('emails_section_customer_booking_approved_temp'), $temp_args);
                        $email_template = self::process_email_template(easybook_addons_get_option('emails_section_customer_booking_approved_temp'), $temp_args);
                
                        $headers = array( 'Reply-To: '.$listing_author->display_name .' ' . '<'.$listing_author->user_email.'>' );
                        self::do_wp_mail( $lb_email, $email_subject, $email_template, $headers);
                    }
                    // listing customer email
                }
                // end if is valid listing
            }
            // end if is valid booking

        }
        
    }
    public static function booking_rooms($booking_id){
        $rooms = get_post_meta( $booking_id, ESB_META_PREFIX.'rooms', true );  
        $room_details = array();
        if( !empty($rooms) ){
            foreach ((array)$rooms as $room) {
                if(isset($room['ID']) && isset($room['quantity']) && (int)$room['quantity'] > 0){
                    $rprice = (float)get_post_meta( $room['ID'], '_price', true );
                    $rquantity = (int)$room['quantity'];
                    $room_details[] = sprintf( __( '<strong>%s</strong>: %d x %s = %s', 'easybook-add-ons' ), get_the_title( $room['ID'] ), $rquantity, easybook_addons_get_price_formated($rprice), easybook_addons_get_price_formated($rquantity*$rprice) );
                }
            }
        }
        return implode("<br>", $room_details);
    }
    public static function booking_rooms_old($booking_id){
        $rooms_persons = get_post_meta( $booking_id, ESB_META_PREFIX.'rooms_old_data', true );
        $room_details = array();
        if( !empty($rooms_persons) ){
            foreach ((array)$rooms_persons as $rdata) {

                $room_details[] = $rdata['title'];
                $roomdates = array();
                foreach ($rdata['rdates'] as $rdte => $rdval) {
                    $roomdates[] = Esb_Class_Date::i18n( $rdte );
                    if( !empty($rdata['quantity']) ) $roomdates[] = sprintf( _x( '<strong>Quantity</strong>: %d x %s', 'email room dates', 'easybook-add-ons' ), $rdata['quantity'], easybook_addons_get_price_formated( $rdval ) );
            
                }

                $room_details[] = implode("<br>", $roomdates);
                
            }
        }
        return implode("<br>", $room_details);
    }
    public static function booking_rooms_new($booking_id){
        $rooms_persons = get_post_meta( $booking_id, ESB_META_PREFIX.'rooms_person_data', true );
        $room_details = array();
        if( !empty($rooms_persons) ){
            foreach ((array)$rooms_persons as $rdata) {

                $room_details[] = $rdata['title'];
                $roomdates = array();
                foreach ($rdata['rdates'] as $rdte => $rdval) {
                    $roomdates[] = Esb_Class_Date::i18n( $rdte );
                    if( !empty($rdata['adults']) ) $roomdates[] = sprintf( _x( '<strong>Adults</strong>: %d x %s', 'email room persons', 'easybook-add-ons' ), $rdata['adults'], easybook_addons_get_price_formated($rdval['adults']) );
                    if( !empty($rdata['children']) ) $roomdates[] = sprintf( _x( '<strong>Children</strong>: %d x %s', 'email room persons', 'easybook-add-ons' ), $rdata['children'], easybook_addons_get_price_formated($rdval['children']) );
                    if( !empty($rdata['infant']) ) $roomdates[] = sprintf( _x( '<strong>Infant</strong>: %d x %s', 'email room persons', 'easybook-add-ons' ), $rdata['infant'], easybook_addons_get_price_formated($rdval['infant']) );
                }

                $room_details[] = implode("<br>", $roomdates);
                
            }
        }
        return implode("<br>", $room_details);
    }

    public static function booking_tickets($booking_id){
        $tickets = get_post_meta( $booking_id, ESB_META_PREFIX.'tickets', true );  
        $details = array();
        if( !empty($tickets) ){
            foreach ((array)$tickets as $ticket) {
                if( isset($ticket['quantity']) && (int)$ticket['quantity'] > 0){
                    
                    $price = (float)$ticket['price'];
                    $quantity = (int)$ticket['quantity'];

                    $details[] = sprintf( __( '<strong>%s</strong>: %d x %s = %s', 'easybook-add-ons' ), $ticket['title'], $quantity, easybook_addons_get_price_formated($price), easybook_addons_get_price_formated($quantity*$price) );

                    
                }
                
            }
        }
        return implode("<br>", $details);
    }
    public static function booking_services($booking_id){
        $book_services = get_post_meta( $booking_id, ESB_META_PREFIX.'book_services', true );  
        $details = array();
        if( is_array($book_services ) && !empty($book_services) ){
            foreach ( $book_services as $service) {
                if( isset($service['quantity']) && (int)$service['quantity'] > 0){
                    
                    $price = (float)$service['price'];
                    $quantity = (int)$service['quantity'];

                    $details[] = sprintf( __( '<strong>%s</strong>: %d x %s = %s', 'easybook-add-ons' ), $service['title'], $quantity, easybook_addons_get_price_formated($price), easybook_addons_get_price_formated($quantity*$price) );

                    
                }
                
            }
        }
        return implode("<br>", $details);
    }
    public static function booking_tour_slots($booking_id){
        $tour_slots = get_post_meta( $booking_id, ESB_META_PREFIX.'tour_slots', true );  
        $details = array();
        if( !empty($tour_slots) ){
            foreach ((array)$tour_slots as $ticket) {
                if( isset($ticket['adults']) && (int)$ticket['adults'] > 0){
                    
                    $price = (float)$ticket['price'];
                    $quantity = (int)$ticket['adults'];

                    $details[] = sprintf( __( '<strong>%s</strong>: Adult %d x %s = %s', 'easybook-add-ons' ), $ticket['title'], $quantity, easybook_addons_get_price_formated($price), easybook_addons_get_price_formated($quantity*$price) );

                    
                }
                if( isset($ticket['children']) && (int)$ticket['children'] > 0){
                    
                    $price = (float)$ticket['child_price'];
                    $quantity = (int)$ticket['children'];

                    $details[] = sprintf( __( '<strong>%s</strong>: Children %d x %s = %s', 'easybook-add-ons' ), $ticket['title'], $quantity, easybook_addons_get_price_formated($price), easybook_addons_get_price_formated($quantity*$price) );

                    
                }
            }
        }
        return implode("<br>", $details);
    }

    public static function lclaim_change_status_to_asked_charge($claim_id = 0){
        if(is_numeric($claim_id)&&(int)$claim_id > 0){
            $claim_post = get_post($claim_id);
            if (null != $claim_post){

                $user_info = get_userdata( get_post_meta( $claim_id, ESB_META_PREFIX.'user_id', true ) );
                $listing_id = get_post_meta( $claim_id, ESB_META_PREFIX.'listing_id', true );

                $subj_args = array(
                    'id' => $claim_id,
                    'date' => current_time( get_option('date_format') ),
                );
                // $email_subject = easybook_addons_process_email_template(easybook_addons_get_option('emails_auth_claim_subject'), $subj_args);
                $email_subject = self::process_email_template(easybook_addons_get_option('emails_auth_claim_subject'), $subj_args);
                $temp_args = array(
                    'author'            => $claim_post->display_name,
                    'date'              => date_i18n( get_option( 'date_format' ), strtotime( $claim_post->post_date ) ),
                    'listing_id'        => $listing_id,
                    'listing_title'     => get_the_title( $listing_id ),
                    'listing_url'       => get_the_permalink( $listing_id ),
                    'add_to_cart'       => easybook_addons_get_add_to_cart_url($claim_id)
                );

                // $email_template = easybook_addons_process_email_template(easybook_addons_get_option('emails_auth_claim_temp'), $temp_args);
                $email_template = self::process_email_template(easybook_addons_get_option('emails_auth_claim_temp'), $temp_args);
                $headers = array( 'Reply-To: '.$listing_author->display_name .' ' . '<'.$listing_author->user_email.'>' );

                self::do_wp_mail( $user_info->user_email , $email_subject, $email_template, $headers);


            }// end check post object
        }// end check id
        
    }

    public static function chat_reply_email($reply_obj){
        // get to user
        $to_user = $reply_obj['uid'];
        if( $reply_obj['user_one'] != $reply_obj['current_user'] ){
            $to_user = $reply_obj['user_one'];
        }

        $receiver = get_userdata( $to_user );
        $replyer = get_userdata( $reply_obj['current_user'] );

        $temp_args = array(
            'receiver'          => $receiver->display_name,
            'reply_text'             => $reply_obj['reply'],
            'date'              => current_time( get_option( 'date_format' ) ),
            'replyer'           => $replyer->display_name,
        );
        $email_template = self::process_email_template( 
            easybook_addons_get_option('new_chat_temp'), 
            $temp_args
        );

        $headers = array( 'Reply-To: '.$replyer->display_name .' ' . '<'.$replyer->user_email.'>' );
        self::do_wp_mail( $receiver->user_email, 'Chat reply', $email_template, $headers);
    }

    public static function author_message_to_email($message, $datas){
        $receiver = get_userdata( $datas['to_user_id'] );
        
        $temp_args = array(
            'author'          => $receiver->display_name,
            'message'        => $datas['lmsg_message'],
            'date'              => current_time( get_option( 'date_format' ) ),
            'name'           => $datas['lmsg_name'],
            'phone'           => $datas['lmsg_phone'],
            'listing'           => get_the_title( $datas['listing_id'] ),
        );
        $email_template = self::process_email_template( 
            easybook_addons_get_option('new_auth_msg_temp'), 
            $temp_args
        );

        $headers = array( 'Reply-To: '.$datas['lmsg_name'] .' ' . '<'.$datas['lmsg_email'].'>' );
        $subject = __( 'New customer message', 'easybook-add-ons' );
        self::do_wp_mail( $receiver->user_email, $subject, $email_template, $headers);
    }

    
}
Esb_Class_Emails::init();
// $class_email = new Esb_Class_Emails();
// $class_email->init();
