<?php
/* add_ons_php */

$login_redirect_page = esb_addons_get_wpml_option('login_redirect_page');
if($login_redirect_page != 'cth_current_page' && is_numeric($login_redirect_page) )
    $login_redirect_url = get_permalink( $login_redirect_page );
else 
    $login_redirect_url = easybook_addons_get_current_url();


?>
    <div class="main-register-wrap modal ctb-modal" id="ctb-logreg-modal"> 
        <div class="reg-overlay"></div>
        <div class="main-register-holder">
            <div class="main-register fl-wrap">
                <div class="ctb-modal-close close-reg color-bg"><i class="fal fa-times"></i></div>
                <ul class="tabs-menu">
                    <li class="current"><a href="#tab-1"><i class="fal fa-sign-in-alt"></i><?php esc_html_e(' Login','easybook-add-ons');?></a></li>
                    <li><a href="#tab-2"><i class="fal fa-user-plus"></i><?php esc_html_e(' Register','easybook-add-ons');?> </a></li>
                </ul>
                <!--tabs -->                       
                <div id="tabs-container">
                    <div class="tab">
                        <!--tab -->
                        <div id="tab-1" class="tab-content">
                            <h3><?php _e( 'Sign In ', 'easybook-add-ons' );?><span><?php bloginfo( 'name' );?></span></h3>
                            <div class="custom-form clearfix">
                                <?php do_action( 'easybook_log_form_before'); ?>
                                <form method="post" id="easybook-login">
                                    <div class="log-message"></div>
                                    <label for="user_login"><?php _e( 'Username or Email Address <span>*</span> ', 'easybook-add-ons' );?></label>
                                    <input id="user_login" name="log" type="text" onClick="this.select()" value="" required>

                                    <label for="user_pass"><?php _e( 'Password <span>*</span> ', 'easybook-add-ons' );?></label>
                                    <input id="user_pass" name="pwd" type="password" onClick="this.select()" value="" required>

                                    <?php easybook_addons_display_recaptcha('loginCaptcha'); ?>

                                    <button type="submit" id="log-submit" class="log-submit-btn"><span><?php _e( 'Log In', 'easybook-add-ons' );?><i class="fa fa-spinner fa-pulse"></i></span></button>

                                    <div class="clearfix"></div>
                                    <div class="filter-tags">
                                        <input name="rememberme" id="rememberme" value="true" type="checkbox">
                                        <label for="rememberme"><?php _e('Remember me','easybook-add-ons');?></label>
                                    </div>
                                    <?php
                                        $nonce = wp_create_nonce( 'easybook-login' );
                                    ?>
                                    <input type="hidden" name="_wpnonce" value="<?php echo $nonce; ?>">
                                    
                                    <input type="hidden" name="redirection" value="<?php echo $login_redirect_url; ?>" />
                                </form>
                                <div class="lost_password">
                                    <a class="lost-password" href="<?php echo wp_lostpassword_url( easybook_addons_get_current_url() ); ?>"><?php _e('Lost Your Password?','easybook-add-ons');?></a>
                                </div>
                            </div>
                        </div>
                        <!--tab end -->
                        <!--tab -->
                        <div class="tab">
                            <div id="tab-2" class="tab-content">
                               <h3><?php _e( 'Sign Up ', 'easybook-add-ons' );?><span><?php bloginfo( 'name' );?></span></h3>
                                <div class="custom-form">
                                    <?php do_action( 'easybook_reg_form_before'); ?>
                                    <form method="post" class="main-register-form" id="easybook-register">
                                        <div class="reg-message"></div>
                                        <?php if(easybook_addons_get_option('register_password') != 'yes'): ?>
                                            <p><?php esc_html_e( 'Account details will be confirmed via email.', 'easybook-add-ons' ); ?></p>
                                        <?php endif; ?>
                                        

                                        <label for="reg_username"><?php _e( 'Username <span>*</span> ', 'easybook-add-ons' );?></label>
                                        <input id="reg_username" name="username" type="text"  onClick="this.select()" value="" required>

                                        <label for="reg_email"><?php _e( 'Email Address <span>*</span> ', 'easybook-add-ons' );?></label>
                                        <input id="reg_email" name="email" type="email"  onClick="this.select()" value="" required>
                                        <?php if(easybook_addons_get_option('register_password') == 'yes'): ?>
                                        <label for="reg_password"><?php _e( 'Password <span>*</span> ', 'easybook-add-ons' );?></label>
                                        <input id="reg_password" name="password" type="password" onClick="this.select()" value="" required>
                                        <?php endif; ?>
                                        <div class="terms_wrap">
                                            <?php if(easybook_addons_get_option('register_role') == 'yes'): ?>
                                            <div class="filter-tags">
                                                <input id="reg_lauthor" name="reg_lauthor" value="1" type="checkbox">
                                                <label for="reg_lauthor"><?php echo esc_html_e('Register as author','easybook-add-ons');?></label>
                                            </div>
                                            <?php endif; ?>
                                            <?php if(easybook_addons_get_option('register_term_text') != ''): ?>
                                            <div class="filter-tags">
                                                <input id="accept_term" name="accept_term" value="1" type="checkbox" required="required">
                                                <label for="accept_term"><?php echo easybook_addons_get_option('register_term_text');?></label>
                                            </div>
                                            <?php endif; ?>
                                            <?php if(easybook_addons_get_option('register_consent_data_text') != ''): ?>
                                            <div class="filter-tags">
                                                <input id="consent_data" name="consent_data" value="1" type="checkbox" required="required">
                                                <label for="consent_data"><?php echo easybook_addons_get_option('register_consent_data_text');?></label>
                                            </div>
                                            <?php endif; ?>
                                        </div>
                                        <div class="clearfix"></div>

                                        <?php easybook_addons_display_recaptcha('regCaptcha'); ?>
                                        
                                        <button type="submit" id="reg-submit" class="log-submit-btn"><span><?php _e( 'Register', 'easybook-add-ons' );?><i class="fa fa-spinner fa-pulse"></i></span></button>

                                        <?php
                                            $nonce = wp_create_nonce( 'easybook-register' );
                                        ?>
                                        <input type="hidden" name="_wpnonce" value="<?php echo $nonce; ?>">

                                        <input type="hidden" name="redirection" value="<?php echo easybook_addons_get_current_url(); ?>" />

                                    </form>
                                </div>
                            </div>
                        </div>
                        <!--tab end -->
                    </div>
                    <!--tabs end -->
                    <?php 
                    $logreg_form_after = easybook_addons_get_option('logreg_form_after');
                    if ( $logreg_form_after != '' ): ?>
                    <div class="log-separator fl-wrap"><span><?php _e( 'or', 'easybook-add-ons' );?></span></div>
                    <div class="soc-log fl-wrap">
                        <?php echo do_shortcode( $logreg_form_after ); ?>
                    </div>
                    <?php 
                    endif; 
                    do_action( 'easybook_logreg_form_after');
                    ?>
                </div>
            </div>
        </div>
    </div>

    <div class="ctb-modal-wrap ctb-modal" id="ctb-resetpsw-modal">
        <div class="ctb-modal-holder">
            <div class="ctb-modal-inner">
                <div class="ctb-modal-close"><i class="fal fa-times"></i></div>
                <h3><?php _e( 'Reset <span>Your Password</span>', 'easybook-add-ons' );?></h3>
                <div class="ctb-modal-content">
                    
                    <form id="forget-password-form" class="reset-password-form custom-form" action="#" method="post">
                        
                        <fieldset>
                            <label for="user_reset"><?php _e( 'Username or Email Address <span>*</span> ', 'easybook-add-ons' );?></label>
                            <input id="user_reset" name="user_login" type="text"  value="" required>
                        </fieldset>
                        <input id="forgetpws-submit" class="btn color-bg" type="submit" value="<?php esc_attr_e( 'Get New Password', 'easybook-add-ons' ); ?>">
                        
                        <?php
                            $nonce = wp_create_nonce( 'easybook-forgetpsw' );
                        ?>
                        <input type="hidden" name="_wpnonce" value="<?php echo $nonce; ?>">
                    </form>
                    <div class="come-back-login">
                        <a class="logreg-modal-open btn-link" href="#"><?php _e('Go Back','easybook-add-ons');?></a>
                    </div>
                </div>
                <!-- end modal-content -->
            </div>
        </div>
    </div>
    <!-- end reset password modal --> 